const { expect } = require('chai'),
    sanitize = require('../sanitize');

describe('Sanitize', () => {
    it('should return undefined for undefined', () => {
        expect(sanitize()).to.be.undefined;
    });

    it('should return string for string', () => {
        expect(sanitize('string')).to.eql('string');
    });

    it('should return object for object', () => {
        expect(sanitize({ foo: 'bar' })).to.eql({ foo: 'bar' });
    });

    it('should return boolean for boolean', () => {
        expect(sanitize(true)).to.eql(true);
        expect(sanitize(false)).to.eql(false);
    });

    it('should return Object for Error Object', () => {
        expect(sanitize(new Error('message'))).to.not.be.an('Error');
        expect(sanitize(new Error('message')).message).to.eql('message');
        expect(sanitize(new Error('message')).stack).to.not.Empty;
    });
});
