#!/usr/bin/env node

const async = require('async'),
    chalk = require('chalk'),
    shell = require('shelljs'),
    ESLintCLIEngine = require('eslint').CLIEngine,

    LINT_SOURCE_DIRS = ['./'];

module.exports = function (callback) {
    console.log(chalk.yellow.bold('\nLinting files in logger module using eslint...'));

    async.waterfall([
        function (next) {
            next(null, (new ESLintCLIEngine()).executeOnFiles(LINT_SOURCE_DIRS));
        },
        function (report, next) {
            let errorReport = ESLintCLIEngine.getErrorResults(report.results),
                errorReportLength = Number(errorReport && errorReport.length) || 0;

            // Log the results
            console.log(ESLintCLIEngine.getFormatter()(report.results));

            errorReportLength === 0 && console.log(chalk.green('\neslint ok!'));

            next(errorReportLength);
        }
    ], callback);
};

!module.parent && module.exports(shell.exit);
