#!/usr/bin/env node

var _ = require('lodash'),
    async = require('async'),
    shell = require('shelljs'),
    path = require('path'),
    chalk = require('chalk'),
    Mocha = require('mocha'),
    utils = require('./utils');

module.exports = function (exit) {
  console.log(chalk.bold.yellow('Running system tests in plugins host module...'));
  async.series([
    function (next) {
      let mocha = new Mocha(),
          src = path.join(__dirname, '..', 'lib');

      _.forEach(utils.extractFiles(src, [], '.test.js'), (file) => {
        mocha.addFile(file);
      });

      return mocha.run(next);
    }
  ], exit);
};

!module.parent && module.exports(shell.exit);
