const fs = require('fs'),
      path = require('path');

/**
 *
 * @param {*} dir
 * @param {*} fileList
 * @param {*} extension
 */
function extractFiles (dir, fileList = [], extension = '.test.js') {
  let files = fs.readdirSync(dir);

  files.forEach(function (file) {
    let filePath = path.resolve(dir, file);
    if (fs.statSync(filePath).isDirectory()) {
      fileList = extractFiles(filePath, fileList, extension);
    }
    else {
      file.indexOf(extension) > 0 && fileList.push(filePath);
    }
  });
  return fileList;
}

module.exports = { extractFiles };
