const { exec } = require('child_process'),
      { expect } = require('chai'),
      path = require('path'),
      fs = require('fs'),
      clear = require('../../../src/clear'),

      TESTS_DIR = path.resolve(__dirname, '..', '..'),
      TEST_TEMP_DIR = path.resolve(TESTS_DIR, '.tmp'),
      TEST_ASSETS_DIR = path.resolve(TESTS_DIR, 'assets'),
      SAMPLE_APP_DIR = path.resolve(TEST_ASSETS_DIR, 'sample-application');

describe('Clear', () => {
  beforeEach((done) => {
    exec(`mkdir -p ${TEST_TEMP_DIR} && cp -R ${SAMPLE_APP_DIR}/* ${TEST_TEMP_DIR}/`, done);
  });

  afterEach((done) => {
    exec(`rm -rf ${TEST_TEMP_DIR}`, done);
  });

  it('should delete all file and folders except one app, eid and eid-old', (done) => {
    const afterClear = ['app', 'sample', 'sample-1234', 'sample-1234-old'],
          clearInputData = {
            eID: 'sample-1234',
            appName: 'sample',
            directory: TEST_TEMP_DIR,
          };

    clear(clearInputData, (err) => {
      expect(err).to.be.null;
      expect(fs.readdirSync(TEST_TEMP_DIR)).to.eql(afterClear);
      done();
    });
  });
});
