#!/usr/bin/env node

var async = require('async'),
    chalk = require('chalk'),
    shell = require('shelljs'),
    ESLintCLIEngine = require('eslint').CLIEngine,

    LINT_SOURCE_DIRS = ['./'];

module.exports = function (exit) {
    console.log(chalk.yellow.bold('\nLinting files in updater module using eslint...'));

    async.waterfall([
        function (next) {
            next(null, (new ESLintCLIEngine()).executeOnFiles(LINT_SOURCE_DIRS));
        },
        function (report, next) {
            var errorReport = ESLintCLIEngine.getErrorResults(report.results);
            console.log(ESLintCLIEngine.getFormatter()(report.results));
            (errorReport && !errorReport.length) && console.log(chalk.green('\neslint ok!'));
            next(Number(errorReport && errorReport.length) || 0);
        }
    ], exit);
};

!module.parent && module.exports(shell.exit);
