#!/usr/bin/env node

var async = require('async'),
    fs = require('fs'),
    shell = require('shelljs'),
    path = require('path'),
    chalk = require('chalk'),
    Mocha = require('mocha');

module.exports = function (exit) {
    console.log(chalk.bold.yellow('Running system tests in updater module...'));
    async.series([
        function (next) {
            var mocha = new Mocha(),
                src = path.join(__dirname, '..', 'tests', 'system');

            fs.readdir(src, (err, files) => { // eslint-disable-line consistent-return
                if (err) { return next(err); }

                files.filter((file) => {
                    return (file.substr(-8) === '.test.js');
                }).forEach((file) => {
                    mocha.addFile(path.join(src, file));
                });

                mocha.run(next);
                mocha = null;

            });
        }
    ], exit);
};

!module.parent && module.exports(shell.exit);
